function xdot=car(t,x)
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
% global T L  a0 a1 p  ;
%
%
xdot=zeros(1,4) ;
% car lenght for the control computation
LC = L * 1.;
% calcul de u1 et u2
%
if (t<0)
  u1=0 ; u2=0 ; 
elseif (t < T) 
%      motion 1
 tau = t/T ;
 phi=tau*tau*(3-2*tau) ;
 dphi = 6*tau*(1-tau) ; 
 a = (1-phi)*a1 + phi*a0 ;
 da = ((a0-a1)/T) * dphi ; 
 f   =   p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
 df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
 ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
 dddf= 6*p(1).*1        + 24*p(2).*(a-a0)   + 60*p(3).*(a-a0)^2 ;
 k = ddf / ((1+df*df)^(3/2)) ;
 dk = ( dddf - 3*df*ddf*ddf/(1+df*df)) / ((1+df*df)^(3/2)) ;
 u1 = ((1+df*df)^(1/2)) * da ;
 u2 =  (L*dk / (1+(L*k)^2) ) * da ;
elseif (t < (2*T) ) 
%     motion 2 
 tau = t/T -1 ;
 phi=tau*tau*(3-2*tau) ;
 dphi = 6*tau*(1-tau) ; 
 a = (1-phi)*a0 + phi*a1 ;
 da = ((a1-a0)/T) * dphi ; 
 f   =   p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
 df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
 ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
 dddf= 6*p(1).*1        + 24*p(2).*(a-a0)   + 60*p(3).*(a-a0)^2 ;
 k = ddf / ((1+df*df)^(3/2)) ;
 dk = ( dddf - 3*df*ddf*ddf/(1+df*df)) / ((1+df*df)^(3/2)) ;
 u1 = ((1+df*df)^(1/2)) * da ;
 u2 =  (LC*dk / (1+(LC*k)^2) ) * da ;
else
 u1=0; u2=0;
end
xdot(1)= u1 * cos(x(1,3)) ;
xdot(2)= u1 * sin(x(1,3)) ;
xdot(3)= u1 * tan(x(1,4)) / L ;
xdot(4)= u2 ;


