function xdot=car2T(t,x)
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
 global T L d1 d2 a0 a1 p  
%
xdot=zeros(1,6) ;
% calcul de u1 et u2
%
if (t<0)
  u1=0 ; u2=0 ; 
elseif (t < T) 
%      motion 
 tau = t/T ;
 phi=tau*tau*(3-2*tau) ;
 dphi = 6*tau*(1-tau) ; 
 a = (1-phi)*a1 + phi*a0 ;
 da = ((a0-a1)/T) * dphi ; 
 [ff df d2f d3f d4f d5f] = car2Tfjet(a) ;
 [k2 k1 k0 dk0]=car2Tfk(df,d2f,d3f,d4f,d5f) ;
 u1 =  ( (1+(d2*k2)^2)*(1+(d1*k1)^2)*(1+df^2) )^(1/2) * da ;
 u2 =  da * L * dk0 / (1+(L*k0)^2) ;
else
 u1=0; u2=0;
end
xdot(1)= u1 * cos(x(1,3)) ;
xdot(2)= u1 * sin(x(1,3)) ;
xdot(3)= u1 * tan(x(1,6)) / L ;
xdot(4)= u1 * sin(x(1,3)-x(1,4)) / d1 ; 
xdot(5)= u1 * sin(x(1,4)-x(1,5)) * cos(x(1,3)-x(1,4)) / d2 ;
xdot(6)= u2 ;


