

  Paris, february 1993.    
 
 These MATLAB programs are free and  illustrate the results presented in the paper
 entitled  " FLATNESS AND MOTION PLANNING: THE CAR WITH N TRAILERS"
 by Pierre Rouchon, Michel Fliess, Jean Levine and Philippe Martin.

 A preliminary presentation will be given at the meeting "pole non lineaire" of the 
  "GR Automatique", 30-31 march 1993 organized by C. Moog  (LAN) at Nantes (France).
  
 The presentation and  the paper are for  ECC'93, Groningen, June 1993. 

 This small package was written in 3 days by myself.
 I am  not at all an expert  in MATLAB.  The programming is thus croase and 
  can be strongly optimized.
 
 This file contains 6 scripts
    mvcr       evcr          dbcr
    mvcr2T   evcr2T      dbcr2T"
  and  7 functions 
     car.m          ptcr.m   
     car2T.m       ptcr2T.m    cr2Tkf.m     cr2Tfjt.m      cr2Tfk.m 
 
 For parking a car, run "mvcr" and "evcr".

 For parking a car with 2 trailers, run "mvcr2T" and "evcr2T"

 For verifying that the control trajectories are correctly calculated
              run "dbcr" and "dbcr2T".
 
 Warning: 
    the curves of the linearizing output are polynomial; thus,  it might
    happen, for the car with 2 trailers mainly, that too exotic initial 
    and final configurations lead to very large  and irregular polynomials and motions. 
    This point can be clearly removed by using other curves. 
   
If you find buggs or if you have any questions , please, contact me.

 ............................................................
 :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
 : Centre Automatique et Systemes, Ecole des Mines de Paris :
 : 60, bd Saint-Michel -- 75272 Paris cedex 06, France      :
 :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
 :..........................................................:













%%%%%%%%% BEGIN OF SCRIPT-FILE mvcr %%%%%%%%%%%%%%%
clear ;
%
%  CAR PACKING VIA FLATNESS AND FRENET FORMULAS
%
%    explicit computation and visualisation of the motions.
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
%
% L:  car length (m) 
% T: basic time interval for one  smooth motion (s)
% a0, a1, p(3): intermediate variables for polynomial 
%           curves definition
%
global T L a0 a1 p  ;
%
T = 1 ; L = 1 ;
a0 =0 ; a1 = 0 ;
p= [0 0 0 ] ;
%
% initial configuration of the car
x1 = 0 ; y1 = 4 ; theta1 = pi/3 ; phi1 = -pi/6 ;
% final configuration of the car 
x2 = 0 ; y2 = 0  ; theta2 =0; phi2 = 0 ;
% Constraints: y1 > y2 and -pi/2 < theta1,2, phi1,2 < pi/2
%
%  sampling of motion 1 --> 0 and 0 --> 2 
     nbpt = 40 ;
% conputation of  intermediate configuration 
x0 = max(x1,x2)   ....
    + L*abs(tan(theta1)) .....
    + L*abs(tan(theta2)) .....
    + L*(abs(y1-y2)/L)^(1/2) ;
y0 = (y1+y2)/2 ;
%
%
% first polynomial curve
a0 = x0 ; b0 = y0 ;
a1 = x1 ; b1 = y1 ; 
M = [ 
  (a1-a0)^3     (a1-a0)^4     (a1-a0)^5 
3*(a1-a0)^2   4*(a1-a0)^3   5*(a1-a0)^4
6*(a1-a0)    12*(a1-a0)^2  20*(a1-a0)^3 
      ] ;
q = [ 
   b1-b0 
   tan(theta1) 
   tan(phi1)/(L*(cos(theta1)^3)) 
    ] ;
p = inv(M)*q ;
%
% computation the first motion, time: 1 -> 0
 state=[ x1 y1 theta1 phi1 ] ;
 for i=1:(nbpt+1)
    tau = (i-1)/nbpt ;
    phi=tau*tau*(3-2*tau) ;
    a = (1-phi)*a1 + phi*a0 ;
    f=  b0+ p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
   df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
   ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
   k = ddf / ((1+df*df)^(3/2)) ;
   state = [ state; a   f  atan(df) atan(k*L)] ; 
 end  
%
%
% second polynomial curve
a0 = x0 ; b0 = y0 ;
a1 = x2 ; b1 = y2 ; 
M = [ 
  (a1-a0)^3     (a1-a0)^4     (a1-a0)^5 
3*(a1-a0)^2   4*(a1-a0)^3   5*(a1-a0)^4
6*(a1-a0)    12*(a1-a0)^2  20*(a1-a0)^3 
      ] ;
q = [ 
      b1-b0 
   tan(theta2) 
   tan(phi2)/(L*(cos(theta2)^3)) 
    ] ;
p = inv(M)*q ;
%
% computation of the second motion 0 --> 2
 for i=1:(nbpt+1)
   tau = (i-1)/nbpt ;
   phi=tau*tau*(3-2*tau) ;
   a = (1-phi)*a0 + phi*a1 ;
   f=  b0+ p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
   df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
   ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
   k = ddf / ((1+df*df)^(3/2)) ;
   state = [ state; a   f  atan(df) atan(k*L)] ;
 end  
%
%
% Graphics 
%
% window size
xmin = min(state(:,1))-0.5*L ;
xmax = max(state(:,1))+1.5*L ;
ymin = min(state(:,2))-1.5*L ;
ymax = max(state(:,2))+1.5*L ;
dd = max([xmax-xmin ymax-ymin]) ;
clg ;
axis('square') ;
axis([xmin xmin+dd ymin ymin+dd]) ;
plot([0 0],[0 0]) ;
hold on ;
clg ;
%
% starting configuration
ptcr(x1,y1,theta1,phi1,L,'-') ;
pause;
%
% end configuration
ptcr(x2,y2,theta2,phi2,L,'--') ;
pause ; 
%
% intermediate configuration (inversion of velocity)
ptcr(x0,y0,0,0,L,'--') ;
pause ;
%
% trajectory of the linearizing output
plot(state(:,1),state(:,2)) ;
pause 
%
% movies 
[n m] = size(state) ;
for i=1:n
  ptcr( state(i,1),state(i,2), ....
            state(i,3),state(i,4),L,'-') ;
  if (i<n)  ;
    ptcr( state(i,1),state(i,2), ....
            state(i,3),state(i,4),L,'i') ;
    plot(state(1:(i+1),1),state(1:(i+1),2),'i') ;
    plot(state((i+1):n,1),state((i+1):n,2),'-') ;
  end ;
end ;
%%%%%%%%% END OF SCRIPT-FILE mvcr %%%%%%%%%%%%%%%







%%%%%%%%%%%%%%% BEGIN OF SCRIPT-FILE evcr   %%%%%%%%%%%%%
clear ;
%
%  CAR PACKING VIA FLATNESS AND FRENET FORMULAS
%
%    explicit computation and visualisation of the motions.
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
%
% L:  car length (m) 
% T: basic time interval for one  smooth motion (s)
% a0, a1, p(3): intermediate variables for polynomial 
%           curves definition
%
global T L a0 a1 p  ;
%
T = 1 ; L = 1 ;
a0 =0 ; a1 = 0 ;
p= [0 0 0 ] ;
%
% initial configuration of the car
x1 = 0 ; y1 = 4 ; theta1 = pi/2.5 ; phi1 = 0 ;
% final configuration of the car 
x2 = 0 ; y2 = 0  ; theta2 =0; phi2 = 0 ;
% Constraints: y1 > y2 and -pi/2 < theta1,2, phi1,2 < pi/2
%
%  sampling of motion 1 --> 0 and 0 --> 2 
     nbpt = 40 ;
% conputation of  intermediate configuration 
x0 = max(x1,x2)   ....
    + L*abs(tan(theta1)) .....
    + L*abs(tan(theta2)) .....
    + 2*L*(abs(y1-y2)/L)^(1/2) ;
y0 = (y1+y2)/2 ;
%
%
% first polynomial curve
a0 = x0 ; b0 = y0 ;
a1 = x1 ; b1 = y1 ; 
M = [ 
  (a1-a0)^3     (a1-a0)^4     (a1-a0)^5 
3*(a1-a0)^2   4*(a1-a0)^3   5*(a1-a0)^4
6*(a1-a0)    12*(a1-a0)^2  20*(a1-a0)^3 
      ] ;
q = [ 
   b1-b0 
   tan(theta1) 
   tan(phi1)/(L*(cos(theta1)^3)) 
    ] ;
p = inv(M)*q ;
%
% computation the first motion, time: 1 -> 0
 state=[ x1 y1 theta1 phi1 ] ;
 for i=1:(nbpt+1)
    tau = (i-1)/nbpt ;
    phi=tau*tau*(3-2*tau) ;
    a = (1-phi)*a1 + phi*a0 ;
   f=  b0+ p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
   df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
   ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
   k = ddf / ((1+df*df)^(3/2)) ;
   state = [ state; a   f  atan(df) atan(k*L)] ; 
 end  
%
%
% second polynomial curve
a0 = x0 ; b0 = y0 ;
a1 = x2 ; b1 = y2 ; 
M = [ 
  (a1-a0)^3     (a1-a0)^4     (a1-a0)^5 
3*(a1-a0)^2   4*(a1-a0)^3   5*(a1-a0)^4
6*(a1-a0)    12*(a1-a0)^2  20*(a1-a0)^3 
      ] ;
q = [ 
      b1-b0 
   tan(theta2) 
   tan(phi2)/(L*(cos(theta2)^3)) 
    ] ;
p = inv(M)*q ;
%
% computation of the second motion 0 --> 2
 for i=1:(nbpt+1)
   tau = (i-1)/nbpt ;
   phi=tau*tau*(3-2*tau) ;
   a = (1-phi)*a0 + phi*a1 ;
   f=  b0+ p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
   df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
   ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
   k = ddf / ((1+df*df)^(3/2)) ;
   state = [ state; a   f  atan(df) atan(k*L)] ;
 end  
%
%
% Graphics 
%
% window size
xmin = min(state(:,1))-0.5*L ;
xmax = max(state(:,1))+1.5*L ;
ymin = min(state(:,2))-1.5*L ;
ymax = max(state(:,2))+1.5*L ;
dd = max([xmax-xmin ymax-ymin]) ;
clg ;
axis('square') ;
axis([xmin xmin+dd ymin ymin+dd]) ;
plot([0 0],[0 0]) ;
hold on ;
clg ;
%
% starting configuration
ptcr(x1,y1,theta1,phi1,L,'-') ;
plot(x1,y1,'o') ;
pause;
%
% end configuration
ptcr(x2,y2,theta2,phi2,L,'-') ;
plot(x2,y2,'o') ;
pause ; 
%
% intermediate configuration (inversion of velocity)
ptcr(x0,y0,0,0,L,'-') ;
plot(x0,y0,'o') ;
pause ;
%
% trajectory of the linearizing output
plot(state(:,1),state(:,2)) ;
pause 
%
% movies 
[n m] = size(state) ;
for i=1:n
  ptcr( state(i,1),state(i,2), ....
            state(i,3),state(i,4),L,'-') ;
  plot(state(i,1),state(i,2),'o') ;
end ;
%%%%%%%%%%%%%%% END OF SCRIPT-FILE evcr   %%%%%%%%%%%%%










%%%%%%%%%%%%%% BEGIN OF SCRIPT-FILE mvcr2T %%%%%%%%%%%%%
clear ;
%
%  CAR WITH 2 TRAILERS PACKING VIA FLATNESS AND FRENET FORMULAS
%
%   explicit computation and visualisation of the motions.
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
% lengths 
%    L:  car length (m) 
%   d1: trailer 1 length (m)
%   d2: trailer 2 length (m)
% T: basic time interval for one  smooth motion (s)
% a0, a1, b0, p(5): intermediate variables for polynomial 
%           curves definition
%
 global T L d1 d2  a0 a1 b0 p  ;
%
clc ;
T = 1 ; 
L = 1 ; d1 = 1.5 ; d2 = 1 ; 
a0 =0 ; a1 = 0 ; b0 = 0 ;
p= [0 0 0 0 0 ] ;
%
% initial configuration
%   the system is described via the coordinates of last trailer
%    
x2_1 = -2 ; y2_1 = 3 ; 
theta2_1= pi/6; theta12_1 =  0 ; theta01_1= 0 ;
                                  phi_1 = 0 ;
%
% final configuration of the car 
x2_2 = 0 ; y2_2 = 0  ;
theta2_2= 0 ; theta12_2 = 0 ; theta01_2= 0 ;
                                   phi_2 = 0 ;
%
% sampling of motion 1 --> 0 and of motion 0 --> 2
        nbpt1 = 40 ; nbpt2 = 40 ;
%
% Constraints: y2_1 > y2_2 and 
% the 4 angles  theta2_1,2
%               theta12_1,2
%               theta01_1,2
%               phi_1,2 
%   must belong to  ] -pi/2 , + pi/2 [
%               
%
% conputation of  intermediate configuration
LL=L+d1+d2
x2_0 = max(x2_1,x2_2) ....
      + LL*abs(tan(theta2_1)) ....
      + LL*abs(tan(theta12_1)) .... 
      + LL*abs(tan(theta01_1)) .... 
      + LL*( abs(y2_1-y2_2)/(d1+d2+L) )^(1/2) ;
y2_0 = (y2_1+y2_2)/2 ;
%
%
% first polynomial curve
a0 = x2_0 ; b0 = y2_0 ;
a1 = x2_1 ; b1 = y2_1 ; 
p=cr2Tkf((b1-b0),theta2_1,theta12_1,theta01_1,phi_1) ;
%
% computation the first motion  1 -> 0
 theta2 = theta2_1 ;
 theta1 = theta12_1+theta2 ;
 theta0 = theta01_1+theta1 ;
 phi = phi_1 ;
 x0=x2_1+d2*cos(theta2)+d1*cos(theta1) ;
 y0=y2_1+d2*sin(theta2)+d1*sin(theta1) ;
 state_1 = [x0 y0 theta0 theta1 theta2 phi] ;
 for i=1:(nbpt1+1)
   tau = (i-1)/nbpt1 ;
   phi=tau*tau*(3-2*tau) ;
   aa = (1-phi)*a1 + phi*a0 ;
   [bb df d2f d3f d4f d5f] = cr2Tfjt(aa) ;
   [k2 k1 k0 dk0]=cr2Tfk(df,d2f,d3f,d4f,d5f) ;
   theta2 = atan(df);
   theta1 = atan(k2*d2)+theta2;
   theta0 = atan(k1*d1) + theta1 ;
   phi = atan(k0*L) ;
   x0=aa+d2*cos(theta2)+d1*cos(theta1) ;
   y0=bb+d2*sin(theta2)+d1*sin(theta1) ;
   state_1 = [ state_1 ; x0 y0 theta0 theta1 theta2 phi] ;
 end ;
%
% second polynomial curve
a0 = x2_0 ; b0 = y2_0 ;
a1 = x2_2 ; b1 = y2_2 ; 
 p=cr2Tkf((b1-b0),theta2_2,theta12_2,theta01_2,phi_2) ;
%
% computation of the second motion  0 -> 2
 theta2 = 0 ;
 theta1 = 0 ;
 theta0 = 0 ;
 phi = 0 ;
 x0=x2_0+d2*cos(theta2)+d1*cos(theta1) ;
 y0=y2_0+d2*sin(theta2)+d1*sin(theta1) ;
 state_2 = [x0 y0 theta0 theta1 theta2 phi] ;
 for i=1:(nbpt2+1)
   tau = (i-1)/nbpt2 ;
   phi=tau*tau*(3-2*tau) ;
   aa = (1-phi)*a0 + phi*a1 ;
   [bb df d2f d3f d4f d5f] = cr2Tfjt(aa) ;
   [k2 k1 k0 dk0]=cr2Tfk(df,d2f,d3f,d4f,d5f) ;
   theta2 = atan(df);
   theta1 = atan(k2*d2)+theta2;
   theta0 = atan(k1*d1) + theta1 ;
   phi = atan(k0*L) ;
   x0=aa+d2*cos(theta2)+d1*cos(theta1) ;
   y0=bb+d2*sin(theta2)+d1*sin(theta1) ;
   state_2 = [ state_2 ; x0 y0 theta0 theta1 theta2 phi] ;
 end ;
%
%
%
%
% Graphics 
%
% window size
xmin = min([min(state_1(:,1)) min(state_2(:,1))]) -1.5*(d1+d2)  ;
xmax = max([max(state_1(:,1)) max(state_1(:,1))]) +1.5*L ;
ymin = min([min(state_1(:,2)) min(state_2(:,2))])-L;
ymax = max([max(state_1(:,2)) max(state_1(:,2))])+L;
dd = max([xmax-xmin ymax-ymin]) ;
clg ;
axis('square') ;
axis([xmin xmin+dd ymin ymin+dd]) ;
plot([0 0],[0 0]) ;
hold on ;
clg ;
%
% starting configuration
   x2=x2_1 ; y2=y2_1 ;
   theta2 = theta2_1 ;
   theta1 = theta12_1+theta2 ;
   theta0 = theta01_1+theta1 ;
   phi = phi_1 ;
   x1=x2+d2*cos(theta2) ;
   y1=y2+d2*sin(theta2) ;
   x0=x1+d1*cos(theta1) ;
   y0=y1+d1*sin(theta1) ;
ptcr2T(x0,y0,theta0,theta1,theta2,phi,'-') ;
pause ;
%
% end configuration
   x2=x2_2 ; y2=y2_2 ;
   theta2 = theta2_2 ;
   theta1 = theta12_2+theta2 ;
   theta0 = theta01_2+theta1 ;
   phi = phi_2 ;
   x1=x2+d2*cos(theta2) ;
   y1=y2+d2*sin(theta2) ;
   x0=x1+d1*cos(theta1) ;
   y0=y1+d1*sin(theta1) ;
ptcr2T(x0,y0,theta0,theta1,theta2,phi,'--') ;
pause ; 
%
% intermediate configuration (inversion of velocity)
   x2=x2_0 ; y2=y2_0 ;
   theta2 = 0 ;
   theta1 = 0;
   theta0 = 0 ;
   phi = 0;
   x1=x2+d2*cos(theta2) ;
   y1=y2+d2*sin(theta2) ;
   x0=x1+d1*cos(theta1) ;
   y0=y1+d1*sin(theta1) ;
ptcr2T(x0,y0,theta0,theta1,theta2,phi,'--') ;
state_1 =[state_1;state_2] ;
x_lin = state_1(:,1)-d1*cos(state_1(:,4))-d2*cos(state_1(:,5)) ;
y_lin = state_1(:,2)-d1*sin(state_1(:,4))-d2*sin(state_1(:,5)) ;
pause;
%
%
%  motion
%
% trajectory of the linearizing output
plot(x_lin,y_lin)
pause ;
%
% movies 
[n m] = size(state_1) ;
for j=1:n
  ptcr2T(state_1(j,1),state_1(j,2),state_1(j,3), ....
      state_1(j,4),state_1(j,5),state_1(j,6),'-' ) ;
 if (j<n)
  ptcr2T(state_1(j,1),state_1(j,2),state_1(j,3), ....
      state_1(j,4),state_1(j,5),state_1(j,6),'i' ) ;
  plot(x_lin(1:(j+1)),y_lin(1:(j+1)),'i') ;
  plot(x_lin((j+1):n),y_lin((j+1):n),'-') ;
  end ;
end ;
%%%%%%%%%%%%%% END OF SCRIPT-FILE mvcr2T %%%%%%%%%%%%%






%%%%%%%%%%%%%%% BEGIN OF SCRIPT-FILE evcr2T %%%%%%%%%%%%
clear ;
%
%  CAR WITH 2 TRAILERS PACKING VIA FLATNESS AND FRENET FORMULAS
%
%   explicit computation and visualisation of the motions.
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
% lengths 
%    L:  car length (m) 
%   d1: trailer 1 length (m)
%   d2: trailer 2 length (m)
% T: basic time interval for one  smooth motion (s)
% a0, a1, b0, p(5): intermediate variables for polynomial 
%           curves definition
%
 global T L d1 d2  a0 a1 b0 p  ;
%
clc ;
T = 1 ; 
L = 1 ; d1 = 1.5 ; d2 = 1 ; 
a0 =0 ; a1 = 0 ; b0 = 0 ;
p= [0 0 0 0 0 ] ;
%
% initial configuration
%   the system is described via the coordinates of last trailer
%    
x2_1 = -2 ; y2_1 = 3 ; 
theta2_1= pi/6; theta12_1 =  0 ; theta01_1= 0 ;
                                  phi_1 = 0 ;
%
% final configuration of the car 
x2_2 = 0 ; y2_2 = 0  ;
theta2_2= 0 ; theta12_2 = 0 ; theta01_2= 0 ;
                                   phi_2 = 0 ;
%
% sampling of motion 1 --> 0 and of motion 0 --> 2
        nbpt1 = 30 ; nbpt2 = 30 ;
%
% Constraints: y2_1 > y2_2 and 
% the 4 angles  theta2_1,2
%               theta12_1,2
%               theta01_1,2
%               phi_1,2 
%   must belong to  ] -pi/2 , + pi/2 [
%               
%
% conputation of  intermediate configuration
LL=L+d1+d2 ;
x2_0 = max(x2_1,x2_2) ....
      + LL*abs(tan(theta2_1)) ....
      + LL*abs(tan(theta12_1)) .... 
      + LL*abs(tan(theta01_1)) .... 
      + 2*LL*( abs(y2_1-y2_2)/(d1+d2+L) )^(1/2) ;
y2_0 = (y2_1+y2_2)/2 ;
%
%
% first polynomial curve
a0 = x2_0 ; b0 = y2_0 ;
a1 = x2_1 ; b1 = y2_1 ; 
p=cr2Tkf((b1-b0),theta2_1,theta12_1,theta01_1,phi_1) ;
%
% computation the first motion  1 -> 0
 theta2 = theta2_1 ;
 theta1 = theta12_1+theta2 ;
 theta0 = theta01_1+theta1 ;
 phi = phi_1 ;
 x0=x2_1+d2*cos(theta2)+d1*cos(theta1) ;
 y0=y2_1+d2*sin(theta2)+d1*sin(theta1) ;
 state_1 = [x0 y0 theta0 theta1 theta2 phi] ;
 for i=1:(nbpt1+1)
   tau = (i-1)/nbpt1 ;
   phi=tau*tau*(3-2*tau) ;
   aa = (1-phi)*a1 + phi*a0 ;
   [bb df d2f d3f d4f d5f] = cr2Tfjt(aa) ;
   [k2 k1 k0 dk0]=cr2Tfk(df,d2f,d3f,d4f,d5f) ;
   theta2 = atan(df);
   theta1 = atan(k2*d2)+theta2;
   theta0 = atan(k1*d1) + theta1 ;
   phi = atan(k0*L) ;
   x0=aa+d2*cos(theta2)+d1*cos(theta1) ;
   y0=bb+d2*sin(theta2)+d1*sin(theta1) ;
   state_1 = [ state_1 ; x0 y0 theta0 theta1 theta2 phi] ;
 end ;
%
% second polynomial curve
a0 = x2_0 ; b0 = y2_0 ;
a1 = x2_2 ; b1 = y2_2 ; 
 p=cr2Tkf((b1-b0),theta2_2,theta12_2,theta01_2,phi_2) ;
%
% computation of the second motion  0 -> 2
 theta2 = 0 ;
 theta1 = 0 ;
 theta0 = 0 ;
 phi = 0 ;
 x0=x2_0+d2*cos(theta2)+d1*cos(theta1) ;
 y0=y2_0+d2*sin(theta2)+d1*sin(theta1) ;
 state_2 = [x0 y0 theta0 theta1 theta2 phi] ;
 for i=1:(nbpt2+1)
   tau = (i-1)/nbpt2 ;
   phi=tau*tau*(3-2*tau) ;
   aa = (1-phi)*a0 + phi*a1 ;
   [bb df d2f d3f d4f d5f] = cr2Tfjt(aa) ;
   [k2 k1 k0 dk0]=cr2Tfk(df,d2f,d3f,d4f,d5f) ;
   theta2 = atan(df);
   theta1 = atan(k2*d2)+theta2;
   theta0 = atan(k1*d1) + theta1 ;
   phi = atan(k0*L) ;
   x0=aa+d2*cos(theta2)+d1*cos(theta1) ;
   y0=bb+d2*sin(theta2)+d1*sin(theta1) ;
   state_2 = [ state_2 ; x0 y0 theta0 theta1 theta2 phi] ;
 end ;
%
%
%
%
% Graphics 
%
% window size
xmin = min([min(state_1(:,1)) min(state_2(:,1))]) -1.5*(d1+d2)  ;
xmax = max([max(state_1(:,1)) max(state_1(:,1))]) +1.5*L ;
ymin = min([min(state_1(:,2)) min(state_2(:,2))])-L;
ymax = max([max(state_1(:,2)) max(state_1(:,2))])+L;
dd = max([xmax-xmin ymax-ymin]) ;
clg ;
axis('square') ;
axis([xmin xmin+dd ymin ymin+dd]) ;
plot([0 0],[0 0]) ;
hold on ;
clg ;
%
% starting configuration
   x2=x2_1 ; y2=y2_1 ;
   theta2 = theta2_1 ;
   theta1 = theta12_1+theta2 ;
   theta0 = theta01_1+theta1 ;
   phi = phi_1 ;
   x1=x2+d2*cos(theta2) ;
   y1=y2+d2*sin(theta2) ;
   x0=x1+d1*cos(theta1) ;
   y0=y1+d1*sin(theta1) ;
ptcr2T(x0,y0,theta0,theta1,theta2,phi,'-') ;
plot(x2,y2,'o') ;
pause ;
%
% end configuration
   x2=x2_2 ; y2=y2_2 ;
   theta2 = theta2_2 ;
   theta1 = theta12_2+theta2 ;
   theta0 = theta01_2+theta1 ;
   phi = phi_2 ;
   x1=x2+d2*cos(theta2) ;
   y1=y2+d2*sin(theta2) ;
   x0=x1+d1*cos(theta1) ;
   y0=y1+d1*sin(theta1) ;
ptcr2T(x0,y0,theta0,theta1,theta2,phi,'-') ;
plot(x2,y2,'o') ;
pause ; 
%
% intermediate configuration (inversion of velocity)
   x2=x2_0 ; y2=y2_0 ;
   theta2 = 0 ;
   theta1 = 0;
   theta0 = 0 ;
   phi = 0;
   x1=x2+d2*cos(theta2) ;
   y1=y2+d2*sin(theta2) ;
   x0=x1+d1*cos(theta1) ;
   y0=y1+d1*sin(theta1) ;
ptcr2T(x0,y0,theta0,theta1,theta2,phi,'-') ;
plot(x2,y2,'o') ;
pause;
%
%
% first and second motions
%
% trajectory of the linearizing output
plot(...
    state_1(:,1)-d1*cos(state_1(:,4))-d2*cos(state_1(:,5)), ....
    state_1(:,2)-d1*sin(state_1(:,4))-d2*sin(state_1(:,5)) ....
     ) ;
plot(...
    state_2(:,1)-d1*cos(state_2(:,4))-d2*cos(state_2(:,5)), ....
    state_2(:,2)-d1*sin(state_2(:,4))-d2*sin(state_2(:,5)) ....
     ) ;
pause ;
%
% movies 
[n m] = size(state_1) ;
for j=1:n
  ptcr2T( state_1(j,1),state_1(j,2),state_1(j,3), .....
            state_1(j,4),state_1(j,5),state_1(j,6),'-' ) ;
   plot(...
      state_1(j,1)-d1*cos(state_1(j,4))-d2*cos(state_1(j,5)), ....
       state_1(j,2)-d1*sin(state_1(j,4))-d2*sin(state_1(j,5)), ....
       'o' ) ;
end ;
[n m] = size(state_2) ;
for j=1:n
  ptcr2T( state_2(j,1),state_2(j,2),state_2(j,3), .....
            state_2(j,4),state_2(j,5),state_2(j,6),'-' ) ;
%
   plot(...
      state_2(j,1)-d1*cos(state_2(j,4))-d2*cos(state_2(j,5)), ....
       state_2(j,2)-d1*sin(state_2(j,4))-d2*sin(state_2(j,5)), ....
       'o' ) ;
end ;
%%%%%%%%%%%%%%% END OF SCRIPT-FILE evcr2T %%%%%%%%%%%%










%%%%%%%%%%%%%%% BEGIN OF SCRIPT-FILE dbcr  %%%%%%%%%%%%
clear ;
%
%  CAR PACKING VIA FLATNESS AND FRENET FORMULAS
%
%   debugg and verification via integration 
%        of the non holonomic system
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
%
% L:  car length (m) 
% T: basic time interval for one  smooth motion (s)
% a0, a1, p(3): intermediate variables for polynomial 
%           curves definition
%
global T L a0 a1 p  ;
%
T = 1 ; L = 1 ;
a0 =0 ; a1 = 0 ;
p= [0 0 0 ] ;
%
% initial configuration of the car
x1 = 0 ; y1 = 4 ; theta1 = pi/2.5 ; phi1 = 0 ;
% final configuration of the car 
x2 = 0 ; y2 = 0  ; theta2 =0; phi2 = 0 ;
% Constraints: y1 > y2 and -pi/2 < theta1,2, phi1,2 < pi/2
%
% conputation of  intermediate configuration 
x0 = max(x1,x2)   ....
    + L*abs(tan(theta1)) .....
    + L*abs(tan(theta2)) .....
    + L*(abs(y1-y2)/L)^(1/2) ;
y0 = (y1+y2)/2 ;
%
%
% first polynomial curve
a0 = x0 ; b0 = y0 ;
a1 = x1 ; b1 = y1 ; 
M = [ 
  (a1-a0)^3     (a1-a0)^4     (a1-a0)^5 
3*(a1-a0)^2   4*(a1-a0)^3   5*(a1-a0)^4
6*(a1-a0)    12*(a1-a0)^2  20*(a1-a0)^3 
      ] ;
q = [ 
   b1-b0 
   tan(theta1) 
   tan(phi1)/(L*(cos(theta1)^3)) 
    ] ;
p = inv(M)*q ;
%
% simulation of the first motion, time: 0 -> T
 [t_1,state_1]=ode23('car',0,T, [ x1 y1 theta1 phi1 ]);
%
%
% second polynomial curve
a0 = x0 ; b0 = y0 ;
a1 = x2 ; b1 = y2 ; 
M = [ 
  (a1-a0)^3     (a1-a0)^4     (a1-a0)^5 
3*(a1-a0)^2   4*(a1-a0)^3   5*(a1-a0)^4
6*(a1-a0)    12*(a1-a0)^2  20*(a1-a0)^3 
      ] ;
q = [ 
      b1-b0 
   tan(theta2) 
   tan(phi2)/(L*(cos(theta2)^3)) 
    ] ;
p = inv(M)*q ;
%
% simulation of the second motion, time: T -> 2T
 [n m]=size(t_1);
 [t_2,state_2]=ode23('car',T,2*T, state_1(n,:) );
%
%
% result array merging
 t_1=t_1(2:n) ; state_1=state_1(2:n,:);
 t=[
    t_1 
    t_2
    ]; 
state = [
         state_1 
         state_2 
        ];
%
%
% graphics 
 clg ; hold off ; axis('normal');
 plot(t,state) ;
 xlabel('time (s)') ; 
 ylabel('x y theta phi ') ;
%%%%%%%%%%%%%%% END OF SCRIPT-FILE dbcr  %%%%%%%%%%%%









%%%%%%%%%%%%%%% BEGIN OF SCRIPT-FILE dbcr2T  %%%%%%%%%%%%
clear ;
%
%  CAR WITH 2 TRAILERS PACKING VIA FLATNESS AND FRENET FORMULAS
%  
%  debugg and verification via the integration 
%        of the non holonomic system.
%
%    February 1993
%
% ............................................................
% :         Pierre ROUCHON  <rouchon@cas.ensmp.fr>           :
% : Centre Automatique et Systemes, Ecole des Mines de Paris :
% : 60, bd Saint Michel -- 75272 PARIS CEDEX 06, France      :
% :    Telephone: (1) 40 51 91 15 --- Fax: (1) 43 54 18 93   :
% :..........................................................:
%
% lengths 
%    L:  car length (m) 
%   d1: trailer 1 length (m)
%   d2: trailer 2 length (m)
% T: basic time interval for one  smooth motion (s)
% a0, a1, p(5): intermediate variables for polynomial 
%           curves definition
%
global T L d1 d2 L d1 d2 a0 a1 b0 p  ;
%
T = 1 ; 
L = 1 ; d1 = 1.5 ; d2 = 1 ; 
a0 =0 ; a1 = 0 ; b0 = 0 ;
p= [0 0 0 0 0 ] ;
%
% initial configuration
%   the system is described via the coordinates of last trailer
x2_1 = 0 ; y2_1 = 6 ; 
theta2_1= pi/8; theta12_1 =  pi/8 ; theta01_1= pi/8 ;
                                  phi_1 = pi/8 ;
%
% final configuration of the car 
x2_2 = 0 ; y2_2 = 0  ;
theta2_2= 0 ; theta12_2 = 0 ; theta01_2= 0 ;
                                   phi_2 = 0 ;
%
% Constraints: y2_1 > y2_2 and 
% the 4 angles  theta2_1,2
%               theta12_1,2
%               theta01_1,2
%               phi_1,2 
%   must belong to  ] -pi/2 , + pi/2 [
%               
%
% conputation of  intermediate configuration
LL=L+d1+d2 ;
x2_0 = max(x2_1,x2_2) ....
      + LL*abs(tan(theta2_1)) ....
      + LL*abs(tan(theta12_1)) .... 
      + LL*abs(tan(theta01_1)) .... 
      + LL*( abs(y2_1-y2_2)/(d1+d2+L) )^(1/2) ;
y2_0 = (y2_1+y2_2)/2 ;
%
%
%
% first polynomial curve
a0 = x2_0 ; b0 = y2_0 ;
a1 = x2_1 ; b1 = y2_1 ; 
p=cr2Tkf((b1-b0),theta2_1,theta12_1,theta01_1,phi_1) ;
%
% simulation of the first motion  0 -> T
%   time t between 0 and T
 theta2 = theta2_1 ;
 theta1 = theta12_1+theta2 ;
 theta0 = theta01_1+theta1 ;
 phi = phi_1 ;
 x0=x2_1+d2*cos(theta2)+d1*cos(theta1) ;
 y0=y2_1+d2*sin(theta2)+d1*sin(theta1) ;
 [t_1,state_1]=ode45('car2T',0,T, ....
                     [ x0 y0 theta0 theta1 theta2 phi ]);
% graphics 
 clg ; hold off ; axis('normal');
 subplot(121);
   plot(t_1,state_1(:,1:2)) ;
   xlabel('time (s)') ; 
   ylabel('x_car y_car (m)') ;
 subplot(122);
   plot(t_1,state_1(:,3:6)) ;
   xlabel('time (s)') ; 
   ylabel('theta0 theta1 theta2 phi (rd)') ;
%
%
% second polynomial curve
a0 = x2_0 ; b0 = y2_0 ;
a1 = x2_2 ; b1 = y2_2 ; 
 p=cr2Tkf((b1-b0),theta2_2,theta12_2,theta01_2,phi_2) ;
%
% simulation of the second motion  T -> 2*T
%
% important remark: due to numerical instability of the  
%  integration during inverse motion, we integrate
%  from the final position 2 to the intermediate position 0.
%
 theta2 = theta2_2 ;
 theta1 = theta12_2+theta2 ;
 theta0 = theta01_2+theta1 ;
 phi = phi_2 ;
 x0=x2_2+d2*cos(theta2)+d1*cos(theta1) ;
 y0=y2_2+d2*sin(theta2)+d1*sin(theta1) ;
 [t_2,state_2]=ode45('car2T',0,T, ....
                     [ x0 y0 theta0 theta1 theta2 phi ]);
%
%
%
% graphics 
  t_2 = 2*T - t_2 ;
 clg ; hold off ; axis('normal');
 subplot(121);
   plot(t_2,state_2(:,1:2)) ;
   xlabel('time (s)') ; 
   ylabel('x_car y_car (m)') ;
 subplot(122);
   plot(t_2,state_2(:,3:6)) ;
   xlabel('time (s)') ; 
   ylabel('theta0 theta1 theta2 phi (rd)') ;
%%%%%%%%%%%%%%% END OF SCRIPT-FILE dbcr2T  %%%%%%%%%%%%








%%%%%%%%% BEGIN OF FUNCTION-FILE car.m %%%%%%%%%%%%%%%%
function xdot=car(t,x)
%
%
% global T L  a0 a1 p  ;
%
%
xdot=zeros(1,4) ;
% car lenght for the control computation
LC = L * 1.;
% calcul de u1 et u2
%
if (t<0)
  u1=0 ; u2=0 ; 
elseif (t < T) 
%      motion 1
 tau = t/T ;
 phi=tau*tau*(3-2*tau) ;
 dphi = 6*tau*(1-tau) ; 
 a = (1-phi)*a1 + phi*a0 ;
 da = ((a0-a1)/T) * dphi ; 
 f   =   p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
 df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
 ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
 dddf= 6*p(1).*1        + 24*p(2).*(a-a0)   + 60*p(3).*(a-a0)^2 ;
 k = ddf / ((1+df*df)^(3/2)) ;
 dk = ( dddf - 3*df*ddf*ddf/(1+df*df)) / ((1+df*df)^(3/2)) ;
 u1 = ((1+df*df)^(1/2)) * da ;
 u2 =  (L*dk / (1+(L*k)^2) ) * da ;
elseif (t < (2*T) ) 
%     motion 2 
 tau = t/T -1 ;
 phi=tau*tau*(3-2*tau) ;
 dphi = 6*tau*(1-tau) ; 
 a = (1-phi)*a0 + phi*a1 ;
 da = ((a1-a0)/T) * dphi ; 
 f   =   p(1).*(a-a0)^3 +    p(2).*(a-a0)^4 +    p(3).*(a-a0)^5 ;
 df  = 3*p(1).*(a-a0)^2 +  4*p(2).*(a-a0)^3 +  5*p(3).*(a-a0)^4 ;
 ddf = 6*p(1).*(a-a0)   + 12*p(2).*(a-a0)^2 + 20*p(3).*(a-a0)^3 ;
 dddf= 6*p(1).*1        + 24*p(2).*(a-a0)   + 60*p(3).*(a-a0)^2 ;
 k = ddf / ((1+df*df)^(3/2)) ;
 dk = ( dddf - 3*df*ddf*ddf/(1+df*df)) / ((1+df*df)^(3/2)) ;
 u1 = ((1+df*df)^(1/2)) * da ;
 u2 =  (LC*dk / (1+(LC*k)^2) ) * da ;
else
 u1=0; u2=0;
end
xdot(1)= u1 * cos(x(1,3)) ;
xdot(2)= u1 * sin(x(1,3)) ;
xdot(3)= u1 * tan(x(1,4)) / L ;
xdot(4)= u2 ;
%%%%%%%%% END OF FUNCTION-FILE car.m %%%%%%%%%%%%%%%%





%%%%%%%%% BEGIN OF FUNCTION-FILE car2T.m %%%%%%%%%%%%
function xdot=car2T(t,x)
%
% global T L d1 d2 a0 a1 p  
%
xdot=zeros(1,6) ;
% calcul de u1 et u2
%
if (t<0)
  u1=0 ; u2=0 ; 
elseif (t < T) 
%      motion 
 tau = t/T ;
 phi=tau*tau*(3-2*tau) ;
 dphi = 6*tau*(1-tau) ; 
 a = (1-phi)*a1 + phi*a0 ;
 da = ((a0-a1)/T) * dphi ; 
 [ff df d2f d3f d4f d5f] = cr2Tfjt(a) ;
 [k2 k1 k0 dk0]=cr2Tfk(df,d2f,d3f,d4f,d5f) ;
 u1 =  ( (1+(d2*k2)^2)*(1+(d1*k1)^2)*(1+df^2) )^(1/2) * da ;
 u2 =  da * L * dk0 / (1+(L*k0)^2) ;
else
 u1=0; u2=0;
end
xdot(1)= u1 * cos(x(1,3)) ;
xdot(2)= u1 * sin(x(1,3)) ;
xdot(3)= u1 * tan(x(1,6)) / L ;
xdot(4)= u1 * sin(x(1,3)-x(1,4)) / d1 ; 
xdot(5)= u1 * sin(x(1,4)-x(1,5)) * cos(x(1,3)-x(1,4)) / d2 ;
xdot(6)= u2 ;
%%%%%%%%%% END OF FUNCTION-FILE car2T.m  %%%%%%%%%%%%%






%%%%%%%%%% BEGIN OF FUNCTION-FILE  cr2Tfjt.m %%%%%%%%%%%%%%
function [ff,df,d2f,d3f,d4f,d5f]=cr2Tfjt(a)
%
%
% 
% global T L d1 d2 Lv d1v d2v a0 a1 p  
%
M= [
    (a-a0)^5      (a-a0)^6     (a-a0)^7     (a-a0)^8       (a-a0)^9 
  5*(a-a0)^4    6*(a-a0)^5   7*(a-a0)^6    8*(a-a0)^7    9*(a-a0)^8 
 20*(a-a0)^3   30*(a-a0)^4  42*(a-a0)^5   56*(a-a0)^6   72*(a-a0)^7 
 60*(a-a0)^2  120*(a-a0)^3 210*(a-a0)^4  336*(a-a0)^5  504*(a-a0)^6 
120*(a-a0)^1  360*(a-a0)^2 840*(a-a0)^3 1680*(a-a0)^4 3024*(a-a0)^5 
120  720*(a-a0)^1 2520*(a-a0)^2 6720*(a-a0)^3 15120*(a-a0)^4 
      ]*p ;
ff  = M(1) + b0 ;
df  = M(2) ;
d2f = M(3) ;
d3f = M(4) ;
d4f = M(5) ;
d5f = M(6) ;
%%%%%%%%%% END OF FUNCTION-FILE  cr2Tfjt.m %%%%%%%%%%%%%%






%%%%%%%%%% BEGIN OF FUNCTION-FILE cr2Tfk.m %%%%%%%%%%%%%%%
function [k2,k1,k0,dk0]=cr2Tfk(df,d2f,d3f,d4f,d5f)
%
%
% computation of curvatures from derivatives of b=f(a)
% global T L d1 d2 a0 a1 p  
%
g = (1+df^2)^(-1/2);
dg = - df*d2f*g^3 ;
d2g = - g*g*(d2f^2*g+df*d3f*g+3*df*d2f*dg) ;
d3g = ....
- 2*g*dg*(d2f^2*g+df*d3f*g+3*df*d2f*dg) ....
- g^2*(3*d2f*d3f*g+df*d4f*g ....
       + 4*d2f^2*dg+4*df*d3f*dg+3*df*d2f*d2g) ;
%
k2  = d2f * g^3  ;
dk2 = d3f*g^3 + 3*d2f*g^2*dg ;
d2k2 = g^2*(d4f*g+6*d3f*dg+3*d2f*d2g) + 6*g*dg^2*d2f ;
d3k2 = 2*g*dg*(d4f*g+6*d3f*dg+3*d2f*d2g) ....
 + g^2*(d5f*g+7*d4f*dg+9*d3f*d2g+3*d2f*d3g) ....
 +6*dg^3*d2f+12*g*dg*d2g*d2f+6*g*dg^2*d3f ;
%
g2 = (1+(d2*k2)^2)^(-1/2) ;
dg2 = -d2^2*k2*dk2*g2^3 ;
d2g2 = -d2^2*g2^2*(dk2^2*g2+k2*d2k2*g2+3*k2*dk2*dg2) ;
%
h2 = g2^3*g ;
dh2 = g2^2*(3*dg2*g+g2*dg);
d2h2 = 2*g2*dg2*(3*dg2*g+g2*dg) ....
     + g2^2*(3*d2g2*g+4*dg2*dg+g2*d2g) ;
%
k1 = g2*k2 + d2*h2*dk2 ;
dk1 = dg2*k2 + g2*dk2 + d2 * (dh2*dk2+h2*d2k2) ;
d2k1 = d2g2*k2 + 2*dg2*dk2 + g2*d2k2 ....
   + d2 * (d2h2*dk2+2*dh2*d2k2+h2*d3k2) ;
%
g1 = (1+(d1*k1)^2)^(-1/2) ;
dg1 = - d1^2*k1*dk1*g1^3 ;
%
k0 = g1*k1 + d1*g1^3*g2*g*dk1 ;
dk0 = dg1*k1 + g1*dk1 ....
 + d1*g1^2*(3*dg1*g2*g*dk1+g1*dg2*g*dk1 ....
          +  g1*g2*dg*dk1+g1*g2*g*d2k1) ;
%%%%%%%%%% END OF FUNCTION-FILE cr2Tfk.m %%%%%%%%%%%%%%%






%%%%%%%%%%% BEGIN OF FUNCTION-FILE cr2Tkf.m  %%%%%%%%%%%%%%%
function coef=cr2Tkf(b,theta2,theta12,theta01,phi)
%
%
% 
% global T L d1 d2 Lv d1v d2v a0 a1 p  
%
M = [ 
  1*(a1-a0)^5    1*(a1-a0)^6   1*(a1-a0)^7    1*(a1-a0)^8    1*(a1-a0)^9 
  5*(a1-a0)^4    6*(a1-a0)^5   7*(a1-a0)^6    8*(a1-a0)^7    9*(a1-a0)^8 
 20*(a1-a0)^3   30*(a1-a0)^4  42*(a1-a0)^5   56*(a1-a0)^6   72*(a1-a0)^7 
 60*(a1-a0)^2  120*(a1-a0)^3 210*(a1-a0)^4  336*(a1-a0)^5  504*(a1-a0)^6 
120*(a1-a0)^1  360*(a1-a0)^2 840*(a1-a0)^3 1680*(a1-a0)^4 3024*(a1-a0)^5 
      ] ;
%
%
df = tan(theta2) ;
%
% curvatures
k2=tan(theta12)/d2;k1=tan(theta01)/d1;k0=tan(phi)/L;
% 
ddf = k2*((1+df*df)^(3/2)) ;
%
% derivative of k2
dk2ds2 = ( (1+(d2*k2)^2)/d2 )*( (1+(d2*k2)^2)^(1/2)*k1 - k2 ) ;
dk2 = (1+df*df)^(1/2) * dk2ds2 ;
%
dddf = dk2 * (1+df*df)^(3/2)  + 3*k2*df*ddf*(1+df*df)^(1/2) ;
%
% second derivative of k2
dk1ds1 = ( (1+(d1*k1)^2)/d1 )*( (1+(d1*k1)^2)^(1/2)*k0 - k1 ) ;
dk1ds2 = dk1ds1 *  (1+(d2*k2)^2)^(1/2) ;
%
ddk2ds2 =  ....
  3*d2*k2*dk2ds2*(1+(d2*k2)^2)^(1/2)*k1 ....
+ (1+(d2*k2)^2)^(3/2)*dk1ds2/d2 ...
- (1/d2+3*d2*k2*k2)*dk2ds2 ;
%
ddk2 = .... 
   df*ddf*((1+df*df)^(-1/2))*dk2ds2 ....
 + (1+df*df)*ddk2ds2 ; 
%
ddddf =  ....
   ddk2 * (1+df*df)^(3/2) ....
 + 6*dk2*df*ddf*(1+df*df)^(1/2) ....
 + 3*k2*ddf*ddf*(1+df*df)^(1/2) ....
 + 3*k2*df*dddf*(1+df*df)^(1/2) ....
 + 3*k2*(df*ddf)^2*(1+df*df)^(-1/2) ;
%
%
%
%
coef =inv(M)* [b;df;ddf;dddf;ddddf] ;
%%%%%%%%%%% END OF FUNCTION-FILE cr2Tkf.m  %%%%%%%%%%%%%%%






%%%%%%%%%% BEGIN OF FUNCTION-FILE ptcr.m %%%%%%%%%%%%%%%%
function ptcr(x,y,theta,phi,length,symbol)
%
% 
% plot the car 
%
% rear wheels
wheel1 =  [ -1/8 1/8 ;  1/6  1/6 ] ; 
wheel2 =  [ -1/8 1/8 ; -1/6 -1/6 ] ;
% front wheels
wheel3 = [
(1-cos(phi)/8)   (1+cos(phi)/8)
(1/6-sin(phi)/8) (1/6+sin(phi)/8) 
         ] ;
wheel4 = [
(1-cos(phi)/8)    (1+cos(phi)/8)
(-1/6-sin(phi)/8) (-1/6+sin(phi)/8) 
         ] ;
% 
% car + wheels
xy_car = [ [
    -1/3   7/6   4/3  4/3  7/6  -1/3  -1/3
    -1/3  -1/3  -1/6  1/6  1/3   1/3  -1/3
         ] wheel1 wheel2 wheel3 wheel4 ] ;
xy_car = ....
  [x x x x x x x x x x x x x x x 
   y y y y y y y y y y y y y y y ] + .... 
   length*[cos(theta) -sin(theta);sin(theta) cos(theta)]*xy_car  ;
%
 plot(xy_car(1,1:7),xy_car(2,1:7),symbol) ;
% rear wheel 1
 plot(xy_car(1,8:9),xy_car(2,8:9),symbol) ;
% rear wheel 2
 plot(xy_car(1,10:11),xy_car(2,10:11),symbol) ;
% front wheel 1
 plot(xy_car(1,12:13),xy_car(2,12:13),symbol) ;
% front wheel 2
 plot(xy_car(1,14:15),xy_car(2,14:15),symbol) ;
%%%%%%%%%% END OF FUNCTION-FILE ptcr.m %%%%%%%%%%%%%%%%









%%%%%%%%%% BEGIN OF FUNCTION-FILE ptcr2T.m %%%%%%%%%%%%%%%%
function ptcr2T(x0,y0,theta0,theta1,theta2,phi,symbol)
%
% 
% plot the car with two trailers
%
  theta = theta0 ; x=x0 ; y=y0 ;
% rear wheels
wheel1 =  [ -1/8 1/8 ;  1/6  1/6 ] ; 
wheel2 =  [ -1/8 1/8 ; -1/6 -1/6 ] ;
% front wheels
wheel3 = [
(1-cos(phi)/8)   (1+cos(phi)/8)
(1/6-sin(phi)/8) (1/6+sin(phi)/8) 
         ] ;
wheel4 = [
(1-cos(phi)/8)    (1+cos(phi)/8)
(-1/6-sin(phi)/8) (-1/6+sin(phi)/8) 
         ] ;
% 
% car + wheels
xy_car = [ [
    -1/3   7/6   4/3  4/3  7/6  -1/3  -1/3
    -1/3  -1/3  -1/6  1/6  1/3   1/3  -1/3
         ] wheel1 wheel2 wheel3 wheel4 ] ;
xy_car = ....
  [x x x x x x x x x x x x x x x 
   y y y y y y y y y y y y y y y ] + .... 
   L*[cos(theta) -sin(theta);sin(theta) cos(theta)]....
      *xy_car  ;
%
%
%     Trailer 1
x = x - d1*cos(theta1) ;
y = y - d1*sin(theta1) ;
theta=theta1 ;
xy_T1 = [ .....
 [
-L/3  L/3   L/3  -L/3  -L/3  
-L/3 -L/3 L/3  L/3  -L/3 
 ] .....
 [
 L/3  d1
  0         0
 ] .....
 [ 
-L/8   L/8 
 L/6  L/6 
 ] .... 
 [ 
-L/8   L/8 
-L/6 -L/6 
 ].... 
 ] ;
%
% translation + rotation
xy_T1 = ....
  [x x x x x x x x x x x  
   y y y y y y y y y y y  ] + .... 
[cos(theta) -sin(theta);sin(theta) cos(theta)]*xy_T1  ;

%
%     Trailer 2
x = x - d2*cos(theta2) ;
y = y - d2*sin(theta2) ;
theta=theta2 ;
xy_T2 = [ .....
 [
-L/3  L/3   L/3  -L/3  -L/3  
-L/3 -L/3 L/3  L/3  -L/3 
 ] .....
 [
 L/3  d2
  0         0
 ] .....
 [ 
-L/8   L/8 
 L/6  L/6 
 ] .... 
 [ 
-L/8   L/8 
-L/6 -L/6 
 ].... 
 ] ;
%
% translation + rotation
xy_T2 = ....
  [x x x x x x x x x x x  
   y y y y y y y y y y y  ] + .... 
[cos(theta) -sin(theta);sin(theta) cos(theta)]*xy_T2  ;
%
%
%
% plots
%
%  Car 
 plot(xy_car(1,1:7),xy_car(2,1:7),symbol) ;
% rear wheel 1
 plot(xy_car(1,8:9),xy_car(2,8:9),symbol) ;
% rear wheel 2
 plot(xy_car(1,10:11),xy_car(2,10:11),symbol) ;
% front wheel 1
 plot(xy_car(1,12:13),xy_car(2,12:13),symbol) ;
% front wheel 2
 plot(xy_car(1,14:15),xy_car(2,14:15),symbol) ;
%
%
% trailer 1 
 plot(xy_T1(1,1:5),xy_T1(2,1:5),symbol) ;
% hitch
 plot(xy_T1(1,6:7),xy_T1(2,6:7),symbol) ;
%  wheels 
 plot(xy_T1(1,8:9),xy_T1(2,8:9),symbol) ;
 plot(xy_T1(1,10:11),xy_T1(2,10:11),symbol) ;
%
%
% trailer 2 
 plot(xy_T2(1,1:5),xy_T2(2,1:5),symbol) ;
% hitch
 plot(xy_T2(1,6:7),xy_T2(2,6:7),symbol) ;
%  wheels 
 plot(xy_T2(1,8:9),xy_T2(2,8:9),symbol) ;
 plot(xy_T2(1,10:11),xy_T2(2,10:11),symbol) ;
%%%%%%%%%%%%%% END OF FUNCTION-FILE ptcr2T.m  %%%%%%%%%%%%%%%%%















